diff --git a/src/event.c b/src/event.c
index ac61749..f9edcfc 100644
--- a/src/event.c
+++ b/src/event.c
@@ -45,37 +45,46 @@ handleWindowDamageRect (CompWindow *w,
 			int	   height)
 {
     REGION region;
-    Bool   initial = FALSE;
+    Bool   status = TRUE;
 
     if (!w->redirected || w->bindFailed)
 	return;
 
-    if (!w->damaged)
-    {
-	w->damaged = initial = TRUE;
-	w->invisible = WINDOW_INVISIBLE (w);
-    }
-
     region.extents.x1 = x;
     region.extents.y1 = y;
     region.extents.x2 = region.extents.x1 + width;
     region.extents.y2 = region.extents.y1 + height;
 
-    if (!(*w->screen->damageWindowRect) (w, initial, &region.extents))
+    while (w != &w->screen->root)
     {
+	Bool initial = FALSE;
+
+	if (!w->damaged)
+	{
+	    w->damaged = initial = TRUE;
+	    w->invisible = WINDOW_INVISIBLE (w);
+	}
+
+	status &= (*w->screen->damageWindowRect) (w, initial, &region.extents);
+
+	if (initial)
+	    damageWindowOutputExtents (w);
+
 	region.extents.x1 += w->attrib.x + w->attrib.border_width;
 	region.extents.y1 += w->attrib.y + w->attrib.border_width;
 	region.extents.x2 += w->attrib.x + w->attrib.border_width;
 	region.extents.y2 += w->attrib.y + w->attrib.border_width;
 
+	w = w->parent;
+    }
+
+    if (!status)
+    {
 	region.rects = &region.extents;
 	region.numRects = region.size = 1;
 
 	damageScreenRegion (w->screen, &region);
     }
-
-    if (initial)
-	damageWindowOutputExtents (w);
 }
 
 void
@@ -99,6 +108,9 @@ handleSyncAlarm (CompWindow *w)
 	    XRectangle *rects;
 	    int	       nDamage;
 
+	    if (w->parent->substructureRedirect)
+		leaveSyncWaitState (w);
+
 	    nDamage = w->nDamage;
 	    rects   = w->damageRects;
 	    while (nDamage--)
@@ -130,9 +142,9 @@ moveInputFocusToOtherWindow (CompWindow *w)
     {
 	CompWindow *ancestor;
 
-	if (w->transientFor && w->transientFor != w->screen->root)
+	if (w->transientFor && w->transientFor != w->screen->root.id)
 	{
-	    ancestor = findWindowAtDisplay (display, w->transientFor);
+	    ancestor = findSibling (w, w->transientFor);
 	    if (ancestor && !(ancestor->type & (CompWindowTypeDesktopMask |
 						CompWindowTypeDockMask)))
 	    {
@@ -146,7 +158,7 @@ moveInputFocusToOtherWindow (CompWindow *w)
 	{
 	    CompWindow *a, *focus = NULL;
 
-	    for (a = w->screen->reverseWindows; a; a = a->prev)
+	    for (a = w->screen->root.reverseWindows; a; a = a->prev)
 	    {
 		if (a->clientLeader == w->clientLeader)
 		{
@@ -277,7 +289,7 @@ triggerButtonPressBindings (CompDisplay  *d,
 
 	if (event->window != edgeWindow)
 	{
-	    if (!s->maxGrab || event->window != s->root)
+	    if (!s->maxGrab || event->window != s->root.id)
 		return FALSE;
 	}
 
@@ -1064,7 +1076,7 @@ handleActionEvent (CompDisplay *d,
 			if (event->xclient.window == s->screenEdge[i].id)
 			{
 			    edge = 1 << i;
-			    root = s->root;
+			    root = s->root.id;
 			    break;
 			}
 		    }
@@ -1115,7 +1127,7 @@ handleActionEvent (CompDisplay *d,
 			if (xdndWindow == s->screenEdge[i].id)
 			{
 			    edge = 1 << i;
-			    root = s->root;
+			    root = s->root.id;
 			    break;
 			}
 		    }
@@ -1307,32 +1319,29 @@ handleEvent (CompDisplay *d,
     case ConfigureNotify:
 	w = findWindowAtDisplay (d, event->xconfigure.window);
 	if (w)
-	{
 	    configureWindow (w, &event->xconfigure);
-	}
-	else
-	{
-	    s = findScreenAtDisplay (d, event->xconfigure.window);
-	    if (s)
-		configureScreen (s, &event->xconfigure);
-	}
 	break;
     case CreateNotify:
-	s = findScreenAtDisplay (d, event->xcreatewindow.parent);
-	if (s)
+	w = findWindowAtDisplay (d, event->xcreatewindow.parent);
+	if (w)
 	{
 	    /* The first time some client asks for the composite
 	     * overlay window, the X server creates it, which causes
 	     * an errorneous CreateNotify event.  We catch it and
 	     * ignore it. */
-	    if (s->overlay != event->xcreatewindow.window)
-		addWindow (s, event->xcreatewindow.window, getTopWindow (s));
+	    if (w->screen->overlay != event->xcreatewindow.window)
+		addWindow (w,
+			   event->xcreatewindow.window,
+			   getTopWindow (w));
 	}
 	break;
     case DestroyNotify:
 	w = findWindowAtDisplay (d, event->xdestroywindow.window);
 	if (w)
 	{
+	    if (w->parent->supportingWmCheckWindow == w->id)
+		getSupportingWmCheck (w->parent);
+
 	    moveInputFocusToOtherWindow (w);
 	    destroyWindow (w);
 	}
@@ -1341,11 +1350,8 @@ handleEvent (CompDisplay *d,
 	w = findWindowAtDisplay (d, event->xmap.window);
 	if (w)
 	{
-	    if (w->pendingMaps)
-		w->managed = TRUE;
-
 	    /* been shaded */
-	    if (w->height == 0)
+	    if (w->managed && w->height == 0)
 	    {
 		if (w->id == d->activeWindow)
 		    moveInputFocusToWindow (w);
@@ -1356,7 +1362,7 @@ handleEvent (CompDisplay *d,
 	break;
     case UnmapNotify:
 	w = findWindowAtDisplay (d, event->xunmap.window);
-	if (w)
+	if (w && w->parent)
 	{
 	    /* Normal -> Iconic */
 	    if (w->pendingUnmaps)
@@ -1364,7 +1370,7 @@ handleEvent (CompDisplay *d,
 		setWmState (d, IconicState, w->id);
 		w->pendingUnmaps--;
 	    }
-	    else /* X -> Withdrawn */
+	    else if (w->managed) /* X -> Withdrawn */
 	    {
 		/* Iconic -> Withdrawn */
 		if (w->state & CompWindowStateHiddenMask)
@@ -1392,12 +1398,7 @@ handleEvent (CompDisplay *d,
 	break;
     case ReparentNotify:
 	w = findWindowAtDisplay (d, event->xreparent.window);
-	s = findScreenAtDisplay (d, event->xreparent.parent);
-	if (s && !w)
-	{
-	    addWindow (s, event->xreparent.window, getTopWindow (s));
-	}
-	else if (w)
+	if (w)
 	{
 	    /* This is the only case where a window is removed but not
 	       destroyed. We must remove our event mask and all passive
@@ -1410,6 +1411,11 @@ handleEvent (CompDisplay *d,
 
 	    destroyWindow (w);
 	}
+
+	w = findWindowAtDisplay (d, event->xreparent.parent);
+	if (w && (w->redirectSubwindows || w->substructureRedirect))
+	    addWindow (w, event->xreparent.window, getTopWindow (w));
+
 	break;
     case CirculateNotify:
 	w = findWindowAtDisplay (d, event->xcirculate.window);
@@ -1456,9 +1462,9 @@ handleEvent (CompDisplay *d,
 		    if (w->attrib.map_state == IsViewable)
 		    {
 			if (w->type == CompWindowTypeDesktopMask)
-			    w->screen->desktopWindowCount--;
+			    w->parent->desktopWindowCount--;
 			else if (type == CompWindowTypeDesktopMask)
-			    w->screen->desktopWindowCount++;
+			    w->parent->desktopWindowCount++;
 		    }
 
 		    w->wmType = type;
@@ -1533,6 +1539,12 @@ handleEvent (CompDisplay *d,
 	    if (w)
 		w->clientLeader = getClientLeader (w);
 	}
+	else if (event->xproperty.atom == d->frameWindowAtom)
+	{
+	    w = findWindowAtDisplay (d, event->xproperty.window);
+	    if (w && w->parent && !w->parent->substructureRedirect)
+		w->frame = getFrameWindow (w);
+	}
 	else if (event->xproperty.atom == d->wmIconGeometryAtom)
 	{
 	    w = findWindowAtDisplay (d, event->xproperty.window);
@@ -1681,10 +1693,67 @@ handleEvent (CompDisplay *d,
 	    if (w)
 		updateWindowClassHints (w);
 	}
+	else if (event->xproperty.atom == d->supportingWmCheckAtom ||
+		 event->xproperty.atom == d->supportedAtom)
+	{
+	    w = findWindowAtDisplay (d, event->xproperty.window);
+	    if (w && !w->substructureRedirect)
+		getSupportingWmCheck (w);
+	}
+	else if (event->xproperty.atom == d->syncStateAtom)
+	{
+	    w = findWindowAtDisplay (d, event->xproperty.window);
+	    if (w && w->parent)
+	    {	
+		if (!w->parent->substructureRedirect)
+		{
+		    if (event->xproperty.state == PropertyDelete)
+		    {
+			if (w->parent->syncStateSupport)
+			    syncWait (w);
+		    }
+		    else
+			handleSyncAlarm (w);
+		}
+	    }
+	}
+	else if (event->xproperty.atom == d->winActiveAtom)
+	{
+	    w = findWindowAtDisplay (d, event->xproperty.window);
+	    if (w)
+	    {	
+		if (!w->substructureRedirect)
+		{
+		    Window activeChild;
+		    
+		    activeChild = getActiveWindow (d, w->id);
+		    if (activeChild != w->activeChild)
+		    {
+			w->previousActiveChild = w->activeChild;
+			w->activeChild = activeChild;
+		    }
+
+		    if (!w->parent)
+			d->activeWindow = activeChild;
+		}
+	    }
+	}
+	else if (event->xproperty.atom == d->desktopViewportAtom)
+	{
+	    w = findWindowAtDisplay (d, event->xproperty.window);
+	    if (w && !w->parent)
+	    {
+		if (!w->substructureRedirect)
+		    getDesktopHints (w->screen);
+	    }
+	}
 	break;
     case MotionNotify:
 	break;
     case ClientMessage:
+	if (!windowManagement)
+	    break;
+
 	if (event->xclient.message_type == d->winActiveAtom)
 	{
 	    w = findWindowAtDisplay (d, event->xclient.window);
@@ -1932,7 +2001,7 @@ handleEvent (CompDisplay *d,
 	{
 	    for (s = d->screens; s; s = s->next)
 	    {
-		if (event->xclient.window == s->root ||
+		if (event->xclient.window == s->root.id ||
 		    event->xclient.window == None)
 		{
 		    if (event->xclient.data.l[0])
@@ -1968,6 +2037,17 @@ handleEvent (CompDisplay *d,
 	    if (w)
 		setDesktopForWindow (w, event->xclient.data.l[0]);
 	}
+	else if (event->xclient.message_type == d->desktopViewportAtom)
+	{
+	    s = findScreenAtDisplay (d, event->xclient.window);
+	    if (s)
+		moveScreenViewport (s,
+				    s->x -
+				    (event->xclient.data.l[0] / s->width),
+				    s->y -
+				    (event->xclient.data.l[1] / s->height),
+				    TRUE);
+	}
 	break;
     case MappingNotify:
 	updateModifierMappings (d);
@@ -2026,7 +2106,7 @@ handleEvent (CompDisplay *d,
 
 		    xwcm = adjustConfigureRequestForGravity (w, &xwc,
 							     CWX | CWY,
-							     gravity);
+							     gravity, 1);
 
 		    if ((*w->screen->placeWindow) (w, xwc.x, xwc.y,
 						   &newX, &newY))
@@ -2061,6 +2141,15 @@ handleEvent (CompDisplay *d,
 
 		if (!(w->state & CompWindowStateHiddenMask))
 		{
+		    /* predict that input will be moved to window. this
+		       makes it look like the window became active just
+		       before it got mapped to external applications */
+		    if (w->inputHint && allowFocus)
+			XChangeProperty (d->display, w->screen->root.id,
+					 d->winActiveAtom,
+					 XA_WINDOW, 32, PropModeReplace,
+					 (unsigned char *) &w->id, 1);
+			
 		    w->pendingMaps++;
 		    XMapWindow (d->display, w->id);
 		}
@@ -2165,14 +2254,19 @@ handleEvent (CompDisplay *d,
 	    {
 		unsigned int state = w->state;
 
-		if (w->id != d->activeWindow)
+		if (w->id != w->parent->activeChild)
 		{
-		    d->activeWindow = w->id;
+		    w->parent->previousActiveChild = w->parent->activeChild; 
+		    w->parent->activeChild = w->id;
+
+		    if (w->parent == &w->screen->root)
+			d->activeWindow = w->id;
+
 		    w->activeNum = w->screen->activeNum++;
 
 		    addToCurrentActiveWindowHistory (w->screen, w->id);
 
-		    XChangeProperty (d->display, w->screen->root,
+		    XChangeProperty (d->display, w->screen->root.id,
 				     d->winActiveAtom,
 				     XA_WINDOW, 32, PropModeReplace,
 				     (unsigned char *) &w->id, 1);
@@ -2324,7 +2418,7 @@ handleEvent (CompDisplay *d,
 
 	    for (s = d->screens; s; s = s->next)
 	    {
-		for (w = s->windows; w; w = w->next)
+		for (w = s->root.windows; w; w = w->next)
 		{
 		    if (w->syncAlarm == sa->alarm)
 			break;
diff --git a/src/main.c b/src/main.c
index ff8328d..ec76311 100644
--- a/src/main.c
+++ b/src/main.c
@@ -68,6 +68,9 @@ Bool onlyCurrentScreen = FALSE;
 Bool useCow = TRUE;
 #endif
 
+Bool windowManagement = FALSE;
+Bool manualCompositeManagement = FALSE;
+
 CompMetadata coreMetadata;
 
 static void
@@ -435,6 +438,15 @@ main (int argc, char **argv)
     if (!addDisplay (displayName))
 	return 1;
 
+    while (core.displays->dirtyPluginList)
+    {
+	updatePlugins (core.displays);
+	handleTimeouts (&core.lastTimeout);
+    }
+
+    if (!manageDisplay (core.displays))
+	return 1;
+
     eventLoop ();
 
     if (!disableSm)
diff --git a/src/paint.c b/src/paint.c
index a2051fa..529fdc6 100644
--- a/src/paint.c
+++ b/src/paint.c
@@ -26,6 +26,7 @@
 #include <stdlib.h>
 #include <string.h>
 #include <math.h>
+#include <assert.h>
 
 #include <compiz-core.h>
 
@@ -157,7 +158,7 @@ paintBackground (CompScreen   *s,
     if (!nBox)
 	return;
 
-    if (s->desktopWindowCount)
+    if (s->root.desktopWindowCount)
     {
 	if (bg->name)
 	{
@@ -251,167 +252,54 @@ paintOutputRegion (CompScreen	       *screen,
 		   CompOutput	       *output,
 		   unsigned int	       mask)
 {
-    static Region tmpRegion = NULL;
-    CompWindow    *w;
-    CompCursor	  *c;
-    int		  count, windowMask, odMask, i;
-    CompWindow	  *fullscreenWindow = NULL;
-    CompWalker    walk;
-    Bool          status;
-    Bool          withOffset = FALSE;
-    CompTransform vTransform;
-    int           offX, offY;
-    Region        clip = region;
-
-    if (!tmpRegion)
-    {
-	tmpRegion = XCreateRegion ();
-	if (!tmpRegion)
-	    return;
-    }
+    Region      r = XCreateRegion ();
+    CompPainter painter;
+    CompCursor	*c;
+    int		windowMask = 0;
+
+    assert (r);
+
+    (*screen->initObjectPainter) (screen, &painter);
 
     if (mask & PAINT_SCREEN_TRANSFORMED_MASK)
-    {
-	windowMask     = PAINT_WINDOW_ON_TRANSFORMED_SCREEN_MASK;
-	count	       = 1;
-    }
-    else
-    {
-	windowMask     = 0;
-	count	       = 0;
-    }
+    	windowMask = PAINT_WINDOW_ON_TRANSFORMED_SCREEN_MASK;
 
-    XSubtractRegion (region, &emptyRegion, tmpRegion);
+    if (mask & PAINT_SCREEN_WITH_TRANSFORMED_WINDOWS_MASK)
+    	windowMask |= PAINT_WINDOW_WITH_TRANSFORMED_CHILD_MASK;
 
-    (*screen->initWindowWalker) (screen, &walk);
+    XSubtractRegion (region, &emptyRegion, r);
 
     if (!(mask & PAINT_SCREEN_NO_OCCLUSION_DETECTION_MASK))
     {
-	/* detect occlusions */
-	for (w = (*walk.last) (screen); w; w = (*walk.prev) (w))
-	{
-	    if (w->destroyed)
-		continue;
-
-	    if (!w->shaded)
-	    {
-		if (w->attrib.map_state != IsViewable || !w->damaged)
-		    continue;
-	    }
+	XSubtractRegion (r, &emptyRegion, screen->root.clip);
 
-	    /* copy region */
-	    XSubtractRegion (tmpRegion, &emptyRegion, w->clip);
+	if ((*painter.paintObject) (&screen->root,
+				    &screen->root.paint,
+				    transform,
+				    r,
+				    PAINT_WINDOW_OCCLUSION_DETECTION_MASK))
+	    XSubtractRegion (r, screen->root.region, r);
 
-	    odMask = PAINT_WINDOW_OCCLUSION_DETECTION_MASK;
-		
-	    if ((screen->windowOffsetX != 0 || screen->windowOffsetY != 0) &&
-		!windowOnAllViewports (w))
-	    {
-		withOffset = TRUE;
-
-		getWindowMovementForOffset (w, screen->windowOffsetX,
-					    screen->windowOffsetY,
-					    &offX, &offY);
-
-		vTransform = *transform;
-		matrixTranslate (&vTransform, offX, offY, 0);
-	 
-		XOffsetRegion (w->clip, -offX, -offY);
-
-		odMask |= PAINT_WINDOW_WITH_OFFSET_MASK;
-		status = (*screen->paintWindow) (w, &w->paint, &vTransform,
-						 tmpRegion, odMask);
-	    }
-	    else
-	    {
-		withOffset = FALSE;
-		status = (*screen->paintWindow) (w, &w->paint, transform, tmpRegion,
-						 odMask);
-	    }
-
-	    if (status)
-	    {
-		if (withOffset)
-		{
-		    XOffsetRegion (w->region, offX, offY);
-		    XSubtractRegion (tmpRegion, w->region, tmpRegion);
-		    XOffsetRegion (w->region, -offX, -offY);
-		}
-		else
-		    XSubtractRegion (tmpRegion, w->region, tmpRegion);
-
-		/* unredirect top most fullscreen windows. */
-		if (count == 0 &&
-		    screen->opt[COMP_SCREEN_OPTION_UNREDIRECT_FS].value.b)
-		{
-		    if (XEqualRegion (w->region, &screen->region) &&
-			!REGION_NOT_EMPTY (tmpRegion))
-		    {
-			fullscreenWindow = w;
-		    }
-		    else
-		    {
-			for (i = 0; i < screen->nOutputDev; i++)
-			    if (XEqualRegion (w->region,
-					      &screen->outputDev[i].region))
-				fullscreenWindow = w;
-		    }
-		}
-	    }
-
-	    count++;
-	}
+	windowMask |= PAINT_WINDOW_CLIP_MASK;
     }
 
-    if (fullscreenWindow)
-	unredirectWindow (fullscreenWindow);
-
     if (!(mask & PAINT_SCREEN_NO_BACKGROUND_MASK))
-	paintBackground (screen, tmpRegion,
-			 (mask & PAINT_SCREEN_TRANSFORMED_MASK));
-
-    /* paint all windows from bottom to top */
-    for (w = (*walk.first) (screen); w; w = (*walk.next) (w))
-    {
-	if (w->destroyed)
-	    continue;
-
-	if (w == fullscreenWindow)
-	    continue;
-
-	if (!w->shaded)
-	{
-	    if (w->attrib.map_state != IsViewable || !w->damaged)
-		continue;
-	}
+	paintBackground (screen, r, (mask & PAINT_SCREEN_TRANSFORMED_MASK));
 
-	if (!(mask & PAINT_SCREEN_NO_OCCLUSION_DETECTION_MASK))
-	    clip = w->clip;
+    (*painter.paintObject) (&screen->root,
+			    &screen->root.paint,
+			    transform,
+			    r,
+			    windowMask);
 
-	if ((screen->windowOffsetX != 0 || screen->windowOffsetY != 0) &&
-	    !windowOnAllViewports (w))
-	{
-	    getWindowMovementForOffset (w, screen->windowOffsetX,
-					screen->windowOffsetY, &offX, &offY);
-
-	    vTransform = *transform;
-	    matrixTranslate (&vTransform, offX, offY, 0);
-	    (*screen->paintWindow) (w, &w->paint, &vTransform, clip,
-				    windowMask | PAINT_WINDOW_WITH_OFFSET_MASK);
-	}
-	else
-	{
-	    (*screen->paintWindow) (w, &w->paint, transform, clip,
-				    windowMask);
-	}
-    }
-
-    if (walk.fini)
-	(*walk.fini) (screen, &walk);
+    if (painter.fini)
+	(*painter.fini) (screen, &painter);
 
     /* paint cursors */
     for (c = screen->cursors; c; c = c->next)
-	(*screen->paintCursor) (c, transform, tmpRegion, 0);
+	(*screen->paintCursor) (c, transform, r, 0);
+
+    XDestroyRegion (r);
 }
 
 void
@@ -420,21 +308,15 @@ enableOutputClipping (CompScreen 	  *screen,
 		      Region		  region,
 		      CompOutput 	  *output)
 {
-    GLdouble h = screen->height;
-
-    GLdouble p1[2] = { region->extents.x1, h - region->extents.y2 };
-    GLdouble p2[2] = { region->extents.x2, h - region->extents.y1 };
-
-    GLdouble halfW = output->width / 2.0;
-    GLdouble halfH = output->height / 2.0;
-
-    GLdouble cx = output->region.extents.x1 + halfW;
-    GLdouble cy = (h - output->region.extents.y2) + halfH;
+    GLdouble x1 = region->extents.x1 > 0 ? 1.0 / region->extents.x1 : MAXSHORT;
+    GLdouble y1 = region->extents.y1 > 0 ? 1.0 / region->extents.y1 : MAXSHORT;
+    GLdouble x2 = region->extents.x2 > 0 ? 1.0 / region->extents.x2 : MAXSHORT;
+    GLdouble y2 = region->extents.y2 > 0 ? 1.0 / region->extents.y2 : MAXSHORT;
 
-    GLdouble top[4]    = { 0.0, halfH / (cy - p1[1]), 0.0, 0.5 };
-    GLdouble bottom[4] = { 0.0, halfH / (cy - p2[1]), 0.0, 0.5 };
-    GLdouble left[4]   = { halfW / (cx - p1[0]), 0.0, 0.0, 0.5 };
-    GLdouble right[4]  = { halfW / (cx - p2[0]), 0.0, 0.0, 0.5 };
+    GLdouble top[4]    = { 0.0,  y1, 0.0, -1.0 };
+    GLdouble bottom[4] = { 0.0, -y2, 0.0,  1.0 };
+    GLdouble left[4]   = {  x1, 0.0, 0.0, -1.0 };
+    GLdouble right[4]  = { -x2, 0.0, 0.0,  1.0 };
 
     glPushMatrix ();
     glLoadMatrixf (transform->m);
@@ -461,9 +343,6 @@ disableOutputClipping (CompScreen *screen)
     glDisable (GL_CLIP_PLANE3);
 }
 
-#define CLIP_PLANE_MASK (PAINT_SCREEN_TRANSFORMED_MASK | \
-			 PAINT_SCREEN_WITH_TRANSFORMED_WINDOWS_MASK)
-
 void
 paintTransformedOutput (CompScreen		*screen,
 			const ScreenPaintAttrib *sAttrib,
@@ -481,34 +360,14 @@ paintTransformedOutput (CompScreen		*screen,
 
     (*screen->applyScreenTransform) (screen, sAttrib, output, &sTransform);
 
-    if ((mask & CLIP_PLANE_MASK) == CLIP_PLANE_MASK)
-    {
-	screen->enableOutputClipping (screen, &sTransform, region, output);
-
-	transformToScreenSpace (screen, output, -sAttrib->zTranslate,
-				&sTransform);
-
-	glPushMatrix ();
-	glLoadMatrixf (sTransform.m);
+    transformToScreenSpace (screen, output, -sAttrib->zTranslate, &sTransform);
 
-	paintOutputRegion (screen, &sTransform, region, output, mask);
-
-	glPopMatrix ();
-
-	screen->disableOutputClipping (screen);
-    }
-    else
-    {
-	transformToScreenSpace (screen, output, -sAttrib->zTranslate,
-				&sTransform);
-
-	glPushMatrix ();
-	glLoadMatrixf (sTransform.m);
+    glPushMatrix ();
+    glLoadMatrixf (sTransform.m);
 
-	paintOutputRegion (screen, &sTransform, region, output, mask);
+    paintOutputRegion (screen, &sTransform, region, output, mask);
 
-	glPopMatrix ();
-    }
+    glPopMatrix ();
 }
 
 Bool
@@ -1194,7 +1053,13 @@ drawWindow (CompWindow		 *w,
 	return TRUE;
 
     if (w->attrib.map_state != IsViewable)
-	return TRUE;
+	return FALSE;
+
+    if (!w->damaged)
+	return FALSE;
+
+    if (!w->parent || !w->parent->redirectSubwindows)
+	return FALSE;
 
     if (!w->texture->pixmap && !bindWindow (w))
 	return FALSE;
@@ -1210,6 +1075,44 @@ drawWindow (CompWindow		 *w,
     return TRUE;
 }
 
+static int
+paintOffsetX (CompWindow *w,
+	      int        x)
+{
+    int vWidth = w->screen->width * (w->screen->hsize - 1);
+
+    if (vWidth)
+    {
+	int wx = w->attrib.x + x;
+
+	if (wx - w->input.left < -vWidth)
+	    return x + vWidth + w->screen->width;
+	else if (wx + w->width + w->input.right > vWidth)
+	    return x - vWidth - w->screen->width;
+    }
+
+    return x;
+}
+
+static int
+paintOffsetY (CompWindow *w,
+	      int        y)
+{
+    int vHeight = w->screen->height * (w->screen->vsize - 1);
+
+    if (vHeight)
+    {
+	int wy = w->attrib.y + y;
+    
+	if (wy - w->input.top < -vHeight)
+	    return y + vHeight + w->screen->height;
+	else if (wy + w->height + w->input.bottom > vHeight)
+	    return y - vHeight - w->screen->height;
+    }
+
+    return y;
+}
+
 Bool
 paintWindow (CompWindow		     *w,
 	     const WindowPaintAttrib *attrib,
@@ -1217,8 +1120,10 @@ paintWindow (CompWindow		     *w,
 	     Region		     region,
 	     unsigned int	     mask)
 {
-    FragmentAttrib fragment;
-    Bool	   status;
+    CompWindow  *c;
+    CompWalker  walk;
+    CompPainter painter;
+    Bool	status;
 
     w->lastPaint = *attrib;
 
@@ -1229,38 +1134,395 @@ paintWindow (CompWindow		     *w,
 
     if (mask & PAINT_WINDOW_OCCLUSION_DETECTION_MASK)
     {
-	if (mask & PAINT_WINDOW_TRANSFORMED_MASK)
-	    return FALSE;
+	Bool occlude = TRUE;
 
 	if (mask & PAINT_WINDOW_NO_CORE_INSTANCE_MASK)
-	    return FALSE;
+	    occlude = FALSE;
+
+	if (w->shaded)
+	    occlude = FALSE;
+
+	if (mask & PAINT_WINDOW_TRANSFORMED_MASK)
+	    occlude = FALSE;
 
 	if (mask & PAINT_WINDOW_TRANSLUCENT_MASK)
-	    return FALSE;
+	    occlude = FALSE;
 
-	if (w->shaded)
-	    return FALSE;
+	if (w->attrib.map_state != IsViewable)
+	    occlude = FALSE;
 
-	return TRUE;
+	if (!w->redirected || !w->damaged)
+	    occlude = FALSE;
+
+	(*w->screen->initWindowWalker) (w->screen, w, &walk);
+	(*w->screen->initObjectPainter) (w->screen, &painter);
+
+	c = (*walk.last) (w);
+	if (c)
+	{
+	    Region        r = XCreateRegion ();
+	    CompTransform wTransform = *transform;
+	    int		  count = 0;
+	    CompWindow	  *fullscreenWindow = NULL;
+
+	    assert (r);
+
+	    XIntersectRegion (region, w->region, r);
+
+	    if (w->attrib.x || w->attrib.y)
+	    {
+		matrixTranslate (&wTransform, w->attrib.x, w->attrib.y, 0);
+		XOffsetRegion (r, -w->attrib.x, -w->attrib.y);
+		mask |= PAINT_WINDOW_WITH_OFFSET_MASK;
+	    }
+	
+	    for (; c; c = (*walk.prev) (c))
+	    {
+		CompTransform     cTransform = wTransform;
+		WindowPaintAttrib cPaint = c->paint;
+		int               viewportOffsetX = 0;
+		int               viewportOffsetY = 0;
+		int               offsetMask = 0;
+		
+		if (c->destroyed)
+		    continue;
+
+		cPaint.opacity = MULTIPLY_USHORT (cPaint.opacity,
+						  attrib->opacity);
+		cPaint.brightness = MULTIPLY_USHORT (cPaint.brightness,
+						     attrib->brightness);
+		cPaint.saturation = MULTIPLY_USHORT (cPaint.saturation,
+						     attrib->saturation);
+
+		if (!windowOnAllViewports (c))
+		{
+		    if (w->viewportOffsetX || w->viewportOffsetY)
+		    {
+			viewportOffsetX = paintOffsetX (c, w->viewportOffsetX);
+			viewportOffsetY = paintOffsetY (c, w->viewportOffsetY);
+
+			matrixTranslate (&cTransform,
+					 viewportOffsetX,
+					 viewportOffsetY,
+					 0);
+
+			XOffsetRegion (r,
+				       -viewportOffsetX,
+				       -viewportOffsetY);
+
+			offsetMask = PAINT_WINDOW_WITH_OFFSET_MASK;
+		    }
+		}
+
+		/* copy region */
+		XSubtractRegion (r, &emptyRegion, c->clip);
+
+		if ((*painter.paintObject) (c,
+					    &cPaint,
+					    &cTransform,
+					    r,
+					    mask | offsetMask) && !occlude)
+		    XSubtractRegion (r, c->region, r);
+
+		if (viewportOffsetX || viewportOffsetY)
+		    XOffsetRegion (r,
+				   viewportOffsetX,
+				   viewportOffsetY);
+
+		/* unredirect top most top-level fullscreen windows. */
+		if (!w->parent &&
+		    count == 0 &&
+		    w->screen->opt[COMP_SCREEN_OPTION_UNREDIRECT_FS].value.b)
+		{
+		    if (XEqualRegion (c->region, &w->screen->region) &&
+			!REGION_NOT_EMPTY (r))
+		    {
+			fullscreenWindow = c;
+		    }
+		    else
+		    {
+			int i;
+
+			for (i = 0; i < w->screen->nOutputDev; i++)
+			    if (XEqualRegion (c->region,
+					      &w->screen->outputDev[i].region))
+				fullscreenWindow = c;
+		    }
+		}
+
+		count++;
+	    }
+
+	    if (fullscreenWindow)
+		unredirectWindow (fullscreenWindow);
+
+	    if (!occlude)
+	    {
+		if (w->attrib.x || w->attrib.y)
+		    XOffsetRegion (r, w->attrib.x, w->attrib.y);
+
+		XSubtractRegion (region, w->region, region);
+		XUnionRegion (region, r, region);
+	    }
+
+	    XDestroyRegion (r);
+	}
+
+	if (painter.fini)
+	    (*painter.fini) (w->screen, &painter);
+	if (walk.fini)
+	    (*walk.fini) (w->screen, &walk);
+
+	return occlude;
     }
 
     if (mask & PAINT_WINDOW_NO_CORE_INSTANCE_MASK)
-	return TRUE;
+    {
+	status = TRUE;
+    }
+    else
+    {
+	FragmentAttrib fragment;
 
-    initFragmentAttrib (&fragment, attrib);
+	initFragmentAttrib (&fragment, attrib);
 
-    if (mask & PAINT_WINDOW_TRANSFORMED_MASK ||
-        mask & PAINT_WINDOW_WITH_OFFSET_MASK)
-    {
-	glPushMatrix ();
-	glLoadMatrixf (transform->m);
+	if (mask & (PAINT_WINDOW_TRANSFORMED_MASK |
+		    PAINT_WINDOW_WITH_OFFSET_MASK))
+	{
+	    glPushMatrix ();
+	    glLoadMatrixf (transform->m);
+	}
+
+	status = (*w->screen->drawWindow) (w, transform, &fragment, region, mask);
+
+	if (mask & (PAINT_WINDOW_TRANSFORMED_MASK |
+		    PAINT_WINDOW_WITH_OFFSET_MASK))
+	    glPopMatrix ();
     }
 
-    status = (*w->screen->drawWindow) (w, transform, &fragment, region, mask);
+    (*w->screen->initWindowWalker) (w->screen, w, &walk);
+    (*w->screen->initObjectPainter) (w->screen, &painter);
+
+    c = (*walk.first) (w);
+    if (c)
+    {
+	Region        clip = NULL;
+	CompTransform wTransform = *transform;
+	unsigned int  clipMask = PAINT_WINDOW_WITH_TRANSFORMED_CHILD_MASK;
+
+	if (!(mask & PAINT_WINDOW_CLIP_MASK))
+	{
+	    clip = XCreateRegion ();
+	    assert (clip);
+	    XIntersectRegion (region, w->region, clip);
+	}
+
+	if (w->attrib.x || w->attrib.y)
+	{
+	    matrixTranslate (&wTransform, w->attrib.x, w->attrib.y, 0);
+
+	    mask |= PAINT_WINDOW_WITH_OFFSET_MASK;
 
-    if (mask & PAINT_WINDOW_TRANSFORMED_MASK ||
-        mask & PAINT_WINDOW_WITH_OFFSET_MASK)
-	glPopMatrix ();
+	    if (clip)
+		XOffsetRegion (clip, -w->attrib.x, -w->attrib.y);
+	}
+
+	if (w->redirectSubwindows)
+	{
+	    /* root only need clip planes when transformed */
+	    if (!w->parent)
+		clipMask |= PAINT_WINDOW_ON_TRANSFORMED_SCREEN_MASK;
+
+	    if ((mask & clipMask) == clipMask)
+	    {
+		glPushAttrib (GL_TRANSFORM_BIT);
+
+		if (mask & PAINT_WINDOW_CLIP_MASK)
+		{
+		    REGION reg;
+
+		    reg.rects    = &reg.extents;
+		    reg.numRects = reg.size = 1;
+		    reg.extents  = w->clip->extents;
+
+		    if (reg.extents.x1 < w->region->extents.x1)
+			reg.extents.x1 = w->region->extents.x1;
+		    if (reg.extents.y1 < w->region->extents.y1)
+			reg.extents.y1 = w->region->extents.y1;
+		    if (reg.extents.x2 > w->region->extents.x2)
+			reg.extents.x2 = w->region->extents.x2;
+		    if (reg.extents.y2 > w->region->extents.y2)
+			reg.extents.y2 = w->region->extents.y2;
+
+		    reg.extents.x1 -= w->attrib.x;
+		    reg.extents.y1 -= w->attrib.y;
+		    reg.extents.x2 -= w->attrib.x;
+		    reg.extents.y2 -= w->attrib.y;
+
+		    (*w->screen->enableOutputClipping) (w->screen,
+							&wTransform,
+							&reg,
+							0);
+		}
+		else
+		    (*w->screen->enableOutputClipping) (w->screen,
+							&wTransform,
+							clip,
+							0);
+	    }
+	}
+
+	/* paint all sub-windows from bottom to top */
+	for (; c; c = (*walk.next) (c))
+	{
+	    CompTransform     cTransform = wTransform;
+	    WindowPaintAttrib cPaint = c->paint;
+	    int               viewportOffsetX = 0;
+	    int               viewportOffsetY = 0;
+	    int               offsetMask = 0;
+
+	    if (c->destroyed)
+		continue;
+
+	    cPaint.opacity = MULTIPLY_USHORT (cPaint.opacity,
+					      attrib->opacity);
+	    cPaint.brightness = MULTIPLY_USHORT (cPaint.brightness,
+						 attrib->brightness);
+	    cPaint.saturation = MULTIPLY_USHORT (cPaint.saturation,
+						 attrib->saturation);
+
+	    if (mask & PAINT_WINDOW_CLIP_MASK)
+		clip = c->clip;
+
+	    if (!windowOnAllViewports (c))
+	    {
+		if (w->viewportOffsetX || w->viewportOffsetY)
+		{
+		    viewportOffsetX = paintOffsetX (c, w->viewportOffsetX);
+		    viewportOffsetY = paintOffsetY (c, w->viewportOffsetY);
+
+		    matrixTranslate (&cTransform,
+				     viewportOffsetX,
+				     viewportOffsetY,
+				     0);
+
+		    if (clip != c->clip)
+			XOffsetRegion (clip,
+				       -viewportOffsetX,
+				       -viewportOffsetY);
+
+		    offsetMask = PAINT_WINDOW_WITH_OFFSET_MASK;
+		}
+	    }
+
+	    (*painter.paintObject) (c,
+				    &cPaint,
+				    &cTransform,
+				    clip,
+				    mask | offsetMask);
+
+	    if (clip != c->clip && (viewportOffsetX || viewportOffsetY))
+		XOffsetRegion (clip,
+			       viewportOffsetX,
+			       viewportOffsetY);
+	}
+
+	if (w->redirectSubwindows)
+	{
+	    if ((mask & clipMask) == clipMask)
+		glPopAttrib ();
+	}
+
+	if (!(mask & PAINT_WINDOW_CLIP_MASK))
+	    XDestroyRegion (clip);
+    }
+
+    if (painter.fini)
+	(*painter.fini) (w->screen, &painter);
+    if (walk.fini)
+	(*walk.fini) (w->screen, &walk);
 
     return status;
 }
+
+static void
+drawWindowAndChildren (CompWindow              *w,
+		       const WindowPaintAttrib *attrib,
+		       const CompTransform     *transform,
+		       Region                  region)
+{
+    FragmentAttrib fragment;
+    unsigned int   wMask = PAINT_WINDOW_ON_TRANSFORMED_SCREEN_MASK;
+
+    if (attrib)
+	initFragmentAttrib (&fragment, attrib);
+    else
+	initFragmentAttrib (&fragment, &w->lastPaint);
+
+    if (w->alpha || fragment.opacity != OPAQUE)
+	wMask |= PAINT_WINDOW_TRANSLUCENT_MASK;
+
+    (*w->screen->drawWindow) (w, transform, &fragment, region, wMask);
+
+    if (w->windows)
+    {
+	Region r;
+
+	r = XCreateRegion ();
+	if (r)
+	{
+	    CompWindow *c;
+
+	    XSubtractRegion (region, &emptyRegion, r);
+	    XIntersectRegion (r, w->region, r);
+	    XOffsetRegion (r, -w->attrib.x, -w->attrib.y);
+
+	    glTranslatef (w->attrib.x, w->attrib.y, 0);
+
+	    for (c = w->windows; c; c = c->next)
+		drawWindowAndChildren (c, attrib, transform, r);
+
+	    glTranslatef (-w->attrib.x, -w->attrib.y, 0);
+
+	    XDestroyRegion (r);
+	}
+    }
+}
+
+void
+drawTransformedWindowWithChildren (CompWindow              *w,
+				   const WindowPaintAttrib *attrib,
+				   const CompTransform     *transform)
+{
+    FragmentAttrib fragment;
+    unsigned int   wMask = PAINT_WINDOW_TRANSFORMED_MASK;
+
+    if (attrib)
+	initFragmentAttrib (&fragment, attrib);
+    else
+	initFragmentAttrib (&fragment, &w->lastPaint);
+
+    if (w->alpha || fragment.opacity != OPAQUE)
+	wMask |= PAINT_WINDOW_TRANSLUCENT_MASK;
+
+    glPushMatrix ();
+    glLoadMatrixf (transform->m);
+
+    (*w->screen->drawWindow) (w, transform, &fragment, &infiniteRegion, wMask);
+
+    if (w->windows)
+    {
+	CompWindow *c;
+
+	XOffsetRegion (w->region, -w->attrib.x, -w->attrib.y);
+	glTranslatef (w->attrib.x, w->attrib.y, 0);
+
+	for (c = w->windows; c; c = c->next)
+	    drawWindowAndChildren (c, attrib, transform, w->region);
+
+	glTranslatef (-w->attrib.x, -w->attrib.y, 0);
+	XOffsetRegion (w->region, w->attrib.x, w->attrib.y);
+    }
+
+    glPopMatrix ();
+}
